using System;
using System.Collections;
using System.Threading;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace RfidMultiForm
{
	/// <summary>
	/// CtH[
	/// </summary>
	public class RFIDForm : System.Windows.Forms.Form
	{
		#region ϐE萔̐錾
		//fobObZ[W\ꍇtrueCȂꍇfalse
		bool Debug = false;

		//COM|[gԍ
		const string DefaultComPort = "COM1";
		//BPSiʏ͕ύXsv)
		const int DefaultBaudRate = 57600;
		//ʐMpobt@TCYiʏ͕ύXsvj
		const int DefaultBufferSize = 80;

		//Aǂݎ莞IDǂݎԊuiP:msec)
		const int DefaultInterval = 200; //0.2b

		//AvP[V̏
		private enum Modes{Init, Open, Read};
		private Modes mode = Modes.Init;

		//gݍ킹ACe𗘗p
		bool multiIdEnabled = true;
		//Cxgs
		bool eventEnabled = true;

		//ACeo^pHashtable
		Hashtable itemHolder = new Hashtable();
		//gݍ킹ACeo^
		Hashtable itemMultiHolder = new Hashtable();

		//gݍ킹ACeID̋؂q
		string multiIdSeparater = "&";
		//t@CɃZ[uۂ̊eڂ̋؂q
		private const char FileSeparator = '\t';

		//OvZXĂяoƂɎgXbhi[pnbV
		Hashtable extThreadHolder = new Hashtable();
		//doh߂̔rnbV̐錾
		Hashtable excludeIdHolder = new Hashtable();
		//doh߂̔rnbV̐錾igݍ킹IDpj
		Hashtable excludeIdMultiHolder = new Hashtable();

		//ACeXg̃Xgt@C
		string itemFileName = Application.StartupPath + @"\items.txt";

		//CxgɗpACe
		Item eventItem = null;

		//MpXbh̐錾
		Thread rxThread = null;
		//MpXbh̐錾
		Thread txThread = null;

		//RFIDʐMpNX̐錾
		RFIDComm rfid = null;
		//Mpobt@̐錾
		byte [] txBytes;
		#endregion

		#region RXgN^CfXgN^CȈ
		//RXgN^
		public RFIDForm()
		{
			InitializeComponent();
			rfid = new RFIDComm(DefaultComPort, DefaultBaudRate);
			txBytes = new byte[DefaultBufferSize];

			//ACeo^
			LoadItems();

			Debug = checkBoxDebug.Checked;
			eventEnabled = checkBoxEvent.Checked;
			multiIdEnabled = checkBoxMulti.Checked;

			ChangeComponentState(Modes.Init);
		}

		//fXgN^
		~RFIDForm()
		{
		}

		//AvP[VȈ
		protected override void Dispose( bool disposing )
		{
			//Iɂ̓ACeIɕۑ
			SaveItems();
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			StopAllThreads();
			ClosePort();

			base.Dispose( disposing );
		}
		#endregion


		#region R|[lg̏
		private void InitializeComponent()
		{
			this.buttonReadStop = new System.Windows.Forms.Button();
			this.buttonReadStart = new System.Windows.Forms.Button();
			this.buttonRead = new System.Windows.Forms.Button();
			this.buttonClose = new System.Windows.Forms.Button();
			this.buttonOpen = new System.Windows.Forms.Button();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.comboBoxPort = new System.Windows.Forms.ComboBox();
			this.labelId = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.buttonRegister = new System.Windows.Forms.Button();
			this.listViewId = new System.Windows.Forms.ListView();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.listViewRegisteredId = new System.Windows.Forms.ListView();
			this.listViewRegisteredMulti = new System.Windows.Forms.ListView();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.checkBoxMulti = new System.Windows.Forms.CheckBox();
			this.checkBoxDebug = new System.Windows.Forms.CheckBox();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.checkBoxEvent = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonReadStop
			// 
			this.buttonReadStop.Enabled = false;
			this.buttonReadStop.Location = new System.Drawing.Point(208, 48);
			this.buttonReadStop.Name = "buttonReadStop";
			this.buttonReadStop.Size = new System.Drawing.Size(88, 23);
			this.buttonReadStop.TabIndex = 6;
			this.buttonReadStop.Text = "Aǎ~";
			this.buttonReadStop.Click += new System.EventHandler(this.buttonReadStop_Click);
			// 
			// buttonReadStart
			// 
			this.buttonReadStart.Enabled = false;
			this.buttonReadStart.Location = new System.Drawing.Point(112, 48);
			this.buttonReadStart.Name = "buttonReadStart";
			this.buttonReadStart.Size = new System.Drawing.Size(88, 23);
			this.buttonReadStart.TabIndex = 5;
			this.buttonReadStart.Text = "AǎJn";
			this.buttonReadStart.Click += new System.EventHandler(this.buttonReadStart_Click);
			// 
			// buttonRead
			// 
			this.buttonRead.Enabled = false;
			this.buttonRead.Location = new System.Drawing.Point(24, 48);
			this.buttonRead.Name = "buttonRead";
			this.buttonRead.TabIndex = 4;
			this.buttonRead.Text = "ǎ";
			this.buttonRead.Click += new System.EventHandler(this.buttonRead_Click);
			// 
			// buttonClose
			// 
			this.buttonClose.Enabled = false;
			this.buttonClose.Location = new System.Drawing.Point(216, 16);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.TabIndex = 3;
			this.buttonClose.Text = "ؒf";
			this.buttonClose.Click += new System.EventHandler(this.buttonClose_Click);
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(24, 16);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.TabIndex = 1;
			this.buttonOpen.Text = "ڑ";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(8, 88);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ReadOnly = true;
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(360, 248);
			this.textBoxMessage.TabIndex = 8;
			this.textBoxMessage.Text = "";
			// 
			// comboBoxPort
			// 
			this.comboBoxPort.Items.AddRange(new object[] {
															  "COM1",
															  "COM2",
															  "COM3",
															  "COM4",
															  "COM5",
															  "COM6",
															  "COM7",
															  "COM8",
															  "COM9",
															  "COM10",
															  "COM11",
															  "COM12",
															  "COM13",
															  "COM14",
															  "COM15",
															  "COM16",
															  "COM17",
															  "COM18",
															  "COM19",
															  "COM20"});
			this.comboBoxPort.Location = new System.Drawing.Point(112, 16);
			this.comboBoxPort.Name = "comboBoxPort";
			this.comboBoxPort.Size = new System.Drawing.Size(88, 20);
			this.comboBoxPort.TabIndex = 2;
			this.comboBoxPort.Text = "COM1";
			this.comboBoxPort.SelectedIndexChanged += new System.EventHandler(this.comboBoxPort_SelectedIndexChanged);
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(8, 16);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(72, 16);
			this.labelId.TabIndex = 16;
			this.labelId.Text = "^OIDꗗ";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonReadStop,
																					this.buttonRead,
																					this.comboBoxPort,
																					this.buttonClose,
																					this.buttonReadStart,
																					this.buttonOpen});
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(320, 80);
			this.groupBox1.TabIndex = 20;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "R}h";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonRegister,
																					this.listViewId,
																					this.labelId});
			this.groupBox2.Location = new System.Drawing.Point(392, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(192, 136);
			this.groupBox2.TabIndex = 21;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "ID";
			// 
			// buttonRegister
			// 
			this.buttonRegister.Enabled = false;
			this.buttonRegister.Location = new System.Drawing.Point(48, 112);
			this.buttonRegister.Name = "buttonRegister";
			this.buttonRegister.Size = new System.Drawing.Size(104, 23);
			this.buttonRegister.TabIndex = 21;
			this.buttonRegister.Text = "IIDo^";
			this.buttonRegister.Click += new System.EventHandler(this.buttonRegister_Click);
			// 
			// listViewId
			// 
			this.listViewId.Location = new System.Drawing.Point(16, 32);
			this.listViewId.Name = "listViewId";
			this.listViewId.Size = new System.Drawing.Size(160, 72);
			this.listViewId.TabIndex = 20;
			this.listViewId.View = System.Windows.Forms.View.List;
			this.listViewId.SelectedIndexChanged += new System.EventHandler(this.listViewId_SelectedIndexChanged);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.listViewRegisteredId});
			this.groupBox3.Location = new System.Drawing.Point(392, 144);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(192, 112);
			this.groupBox3.TabIndex = 22;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "o^ςID";
			// 
			// listViewRegisteredId
			// 
			this.listViewRegisteredId.Location = new System.Drawing.Point(16, 16);
			this.listViewRegisteredId.MultiSelect = false;
			this.listViewRegisteredId.Name = "listViewRegisteredId";
			this.listViewRegisteredId.Size = new System.Drawing.Size(160, 88);
			this.listViewRegisteredId.TabIndex = 20;
			this.listViewRegisteredId.View = System.Windows.Forms.View.List;
			this.listViewRegisteredId.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listViewRegisteredId_KeyDown);
			this.listViewRegisteredId.DoubleClick += new System.EventHandler(this.listViewRegisteredId_DoubleClick);
			// 
			// listViewRegisteredMulti
			// 
			this.listViewRegisteredMulti.Location = new System.Drawing.Point(16, 16);
			this.listViewRegisteredMulti.MultiSelect = false;
			this.listViewRegisteredMulti.Name = "listViewRegisteredMulti";
			this.listViewRegisteredMulti.Size = new System.Drawing.Size(160, 80);
			this.listViewRegisteredMulti.TabIndex = 20;
			this.listViewRegisteredMulti.View = System.Windows.Forms.View.List;
			this.listViewRegisteredMulti.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listViewRegisteredMulti_KeyDown);
			this.listViewRegisteredMulti.DoubleClick += new System.EventHandler(this.listViewRegisteredMulti_DoubleClick);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.listViewRegisteredMulti,
																					this.checkBoxMulti});
			this.groupBox4.Location = new System.Drawing.Point(392, 264);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(192, 128);
			this.groupBox4.TabIndex = 23;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "o^ςID̑gݍ킹";
			// 
			// checkBoxMulti
			// 
			this.checkBoxMulti.Checked = true;
			this.checkBoxMulti.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxMulti.Location = new System.Drawing.Point(24, 96);
			this.checkBoxMulti.Name = "checkBoxMulti";
			this.checkBoxMulti.Size = new System.Drawing.Size(152, 24);
			this.checkBoxMulti.TabIndex = 25;
			this.checkBoxMulti.Text = "gݍ킹𗘗p";
			this.checkBoxMulti.CheckedChanged += new System.EventHandler(this.checkBoxMulti_CheckedChanged);
			// 
			// checkBoxDebug
			// 
			this.checkBoxDebug.Location = new System.Drawing.Point(8, 16);
			this.checkBoxDebug.Name = "checkBoxDebug";
			this.checkBoxDebug.Size = new System.Drawing.Size(176, 24);
			this.checkBoxDebug.TabIndex = 17;
			this.checkBoxDebug.Text = "fobObZ[W\";
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.checkBoxEvent,
																					this.checkBoxDebug});
			this.groupBox5.Location = new System.Drawing.Point(8, 344);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(360, 48);
			this.groupBox5.TabIndex = 24;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "ݒ";
			// 
			// checkBoxEvent
			// 
			this.checkBoxEvent.Checked = true;
			this.checkBoxEvent.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxEvent.Location = new System.Drawing.Point(208, 16);
			this.checkBoxEvent.Name = "checkBoxEvent";
			this.checkBoxEvent.Size = new System.Drawing.Size(120, 24);
			this.checkBoxEvent.TabIndex = 18;
			this.checkBoxEvent.Text = "Cxgs";
			this.checkBoxEvent.CheckedChanged += new System.EventHandler(this.checkBoxEvent_CheckedChanged);
			// 
			// RFIDForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(594, 400);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox5,
																		  this.groupBox4,
																		  this.groupBox3,
																		  this.textBoxMessage,
																		  this.groupBox1,
																		  this.groupBox2});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "RFIDForm";
			this.Text = "RFIDeXgptH[(ǎŁj";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region R|[lg̐錾
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonReadStop;
		private System.Windows.Forms.Button buttonReadStart;
		private System.Windows.Forms.Button buttonRead;
		private System.Windows.Forms.Button buttonClose;
		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.ComboBox comboBoxPort;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.ListView listViewId;
		private System.Windows.Forms.ListView listViewRegisteredMulti;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.CheckBox checkBoxDebug;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.CheckBox checkBoxMulti;
		private System.Windows.Forms.CheckBox checkBoxEvent;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.ListView listViewRegisteredId;
		private System.Windows.Forms.Button buttonRegister;
		#endregion


		#region R|[lg̃Cxg
		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			OpenPort();	
		}

		private void buttonRead_Click(object sender, System.EventArgs e)
		{
			SendCommand(IdTx.Inventory);
		}

		private void buttonReadStart_Click(object sender, System.EventArgs e)
		{
			StartTxThread();
			//SendCommand(IdTx.ReadDetail);
		}

		private void buttonClose_Click(object sender, System.EventArgs e)
		{
			ClosePort();
		}

		private void buttonReadStop_Click(object sender, System.EventArgs e)
		{
			StopTxThread();
			//SendCommand(IdTx.Read);
		}

		private void comboBoxPort_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			rfid.Port = (string)comboBoxPort.SelectedItem;
		}

		//ݔFĂJ[hIDnbViƃXg{bNXjɓo^D
		private void buttonRegister_Click(object sender, System.EventArgs e)
		{
			string idStr ="";
			ListViewItem listItem;
			bool multiFlag = false;
			try
			{
				if(listViewId.SelectedItems.Count == 0)
				{
					PrintError("IDIĂ܂D");
					return;
				}
				else if(listViewId.SelectedItems.Count == 1)
				{
					listItem = listViewId.SelectedItems[0];
					idStr = listItem.Text;
				}
				else
				{
					for(int i=0;i<listViewId.SelectedItems.Count;i++)
					{
						idStr = idStr + listViewId.SelectedItems[i].Text + multiIdSeparater;
					}
					idStr = idStr.Substring(0, idStr.Length-1);
					listItem = new ListViewItem(idStr);
					multiFlag = true;
				}
			
				//IDo^ς݂ȂI
				if(multiFlag)
				{
					
					if(itemMultiHolder.Contains(idStr))
					{	
						PrintError("ID͊ɓo^ς݂łD");
						return;
					}
					else
					{
						PrintMessage("IDo^܂D");
						if(!itemMultiHolder.ContainsKey(idStr))
						{
							Item item = new Item(idStr, "","","");
							itemMultiHolder.Add(idStr, item);
						}

						if(listViewRegisteredMulti.Items.Count == 1 && listViewRegisteredMulti.Items[0].Text =="")
						{
							listViewRegisteredMulti.Items[0] = listItem;
						}
						else
						{
							listViewRegisteredMulti.Items.Add(new ListViewItem(idStr));
						}
					}
				}
				else
				{
					//if(listViewRegisteredId.Items.Contains(listItem))
					if(itemHolder.Contains(listItem.Text))
					{	
						PrintError("ID͊ɓo^ς݂łD");
						return;
					}
					else
					{
						PrintMessage("IDo^܂D");
						if(!itemHolder.ContainsKey(idStr))
						{
							Item item = new Item(idStr, "","","");
							itemHolder.Add(idStr, item);
						}

						if(listViewRegisteredId.Items.Count == 1 && listViewRegisteredId.Items[0].Text =="")
						{
							listViewRegisteredId.Items[0] = listItem;
						}
						else
						{
							listViewRegisteredId.Items.Add(new ListViewItem(idStr));
						}
					}
				}
				return;
			}
			catch(Exception ex)
			{
				return;
			}
		}

		//Xg{bNXIDɊ蓖ĂҏWD
		private void listViewRegisteredId_DoubleClick(object sender, System.EventArgs e)
		{
			try
			{
				//ɕҏWłACe͈
				if(listViewRegisteredId.Items.Count == 0 || 
					listViewRegisteredId.SelectedItems.Count == 0 ||  
					listViewRegisteredId.SelectedItems[0].Text == "")
				{
					return;
				}

				string id = listViewRegisteredId.SelectedItems[0].Text;
				Item item = null;

				if(itemHolder.ContainsKey(id))
				{
					item = (Item)itemHolder[id];
				}
				else
				{
					item = new Item(id,"","","");
				}

				ItemForm form = new ItemForm(item);
				DialogResult result = form.ShowDialog();

				if(result == DialogResult.OK)
				{
					if(itemHolder.ContainsKey(id))
					{
						itemHolder[id] = item;
					}
					else
					{
						itemHolder.Add(id, item);
					}
				}

				form.Dispose();
			}
			catch(Exception ex)
			{

			}
		
		}

		private void listViewRegisteredId_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if(e.KeyCode ==Keys.Delete)
				{
					int index = listViewRegisteredId.SelectedIndices[0];
					string id = listViewRegisteredId.Items[index].Text;
					if(listViewRegisteredId.Items[index] != null)
					{
						if(itemHolder.Contains(id))
						{
							itemHolder.Remove(id);
						}
						listViewRegisteredId.Items.RemoveAt(index);
					}
				}
				
			}
			catch(Exception ex)
			{
				
			}
			return;		
		}



		private void listViewId_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(listViewId.SelectedItems.Count > 0)
			{
				buttonRegister.Enabled = true;
			}
			else
			{
				buttonRegister.Enabled = false;
			}

		}



		private void listViewRegisteredMulti_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if(e.KeyCode ==Keys.Delete)
				{
					int index = listViewRegisteredMulti.SelectedIndices[0];
					string id = listViewRegisteredMulti.Items[index].Text;
					if(listViewRegisteredMulti.Items[index] != null)
					{
						if(itemMultiHolder.Contains(id))
						{
							itemMultiHolder.Remove(id);
						}
						listViewRegisteredMulti.Items.RemoveAt(index);
					}
				}
				
			}
			catch(Exception ex)
			{
				
			}
			return;		
		}

		private void listViewRegisteredMulti_DoubleClick(object sender, System.EventArgs e)
		{
			try
			{
				//ɕҏWłACe͈
				if(listViewRegisteredMulti.Items.Count == 0 || 
					listViewRegisteredMulti.SelectedItems.Count == 0 ||  
					listViewRegisteredMulti.SelectedItems[0].Text == "")
				{
					return;
				}

				string id = listViewRegisteredMulti.SelectedItems[0].Text;
				Item item = null;

				if(itemMultiHolder.ContainsKey(id))
				{
					item = (Item)itemMultiHolder[id];
				}
				else
				{
					item = new Item(id,"","","");
				}

				ItemForm form = new ItemForm(item);
				DialogResult result = form.ShowDialog();

				if(result == DialogResult.OK)
				{
					if(itemMultiHolder.ContainsKey(id))
					{
						itemMultiHolder[id] = item;
					}
					else
					{
						itemMultiHolder.Add(id, item);
					}
				}

				form.Dispose();
			}
			catch(Exception ex)
			{

			}
			return;
		}

		private void checkBoxMulti_CheckedChanged(object sender, System.EventArgs e)
		{
			multiIdEnabled = this.checkBoxMulti.Checked;
		}

		private void checkBoxEvent_CheckedChanged(object sender, System.EventArgs e)
		{
			eventEnabled = checkBoxEvent.Checked;
		}

		#endregion


		#region Utilityñ\bh
		
		//NIDƃL[[h̃Xg擾
		//o^ꂽItem̏t@CɕۑD
		private void SaveItems()
		{	
			StreamWriter writer = new StreamWriter(itemFileName, false);

			try
			{
				foreach(Item item in itemHolder.Values)
				{
				
					if(item == null)	break;

					//IvV^u؂蕶ɕϊ
					string options = null;
					foreach(string option in item.options)
					{
						options  = options +  FileSeparator + option;
					}
					//擪̃^u폜
					options = Regex.Replace(options, @"^\t","");					
					string message = string.Format("{0}\t{1}\t{2}\t{3}",item.id, item.name, item.program, options);
					writer.WriteLine(message);
				}
				foreach(Item item in itemMultiHolder.Values)
				{
				
					if(item == null)	break;

					//IvV^u؂蕶ɕϊ
					string options = null;
					foreach(string option in item.options)
					{
						options  = options +  FileSeparator + option;
					}
					//擪̃^u폜
					options = Regex.Replace(options, @"^\t","");					
					string message = string.Format("{0}\t{1}\t{2}\t{3}",item.id, item.name, item.program, options);
					writer.WriteLine(message);
				}
			}
			catch(Exception ex)
			{
				PrintMessage(ex.ToString());
			}
			writer.Close();
		}
		
		//t@Co^ꂽACe[hCnbVɉDD
		private void LoadItems()
		{
			if(!File.Exists(itemFileName)) return;

			StreamReader reader = new StreamReader(itemFileName);

			try
			{
				while(true)
				{
					string line = reader.ReadLine();
					if(line == null) break;
					string [] data = line.Split('\t');
					if(data.Length<3)continue;

					//long id = long.Parse((string)data[0]);
					string id = (string)data[0];
					string name = (string)data[1];
					string program = (string)data[2];
					string [] options = new string[data.Length-3];
					
					for(int i=0;i<options.Length;i++)
					{
						options[i] = data[i+3];
					}

					//id&܂܂ĂΑgݍ킹IDƂēo^
					Match m = Regex.Match(id, multiIdSeparater);
					if(m.Success)
					{
						itemMultiHolder.Add(id, new Item(id, name, program, options));
						if(listViewRegisteredMulti.Items.Count == 1 && listViewRegisteredMulti.Items[0].Text =="")
						{
							listViewRegisteredMulti.Items[0] = new ListViewItem(id);
						}
						else
						{
							listViewRegisteredMulti.Items.Add(new ListViewItem(id));
						}
					}
					else
					{
						itemHolder.Add(id, new Item(id, name, program, options));
						if(listViewRegisteredId.Items.Count == 1 && listViewRegisteredId.Items[0].Text =="")
						{
							listViewRegisteredId.Items[0] = new ListViewItem(id);
						}
						else
						{
							listViewRegisteredId.Items.Add(new ListViewItem(id));
						}
					}
				}
			}
			catch(Exception ex)
			{
				PrintMessage(ex.ToString());
			}
			reader.Close();
		}


		private void PrintMessage(string m, params object []args)
		{
			
			string message = String.Format(m, args);
			//Console.WriteLine(message);
			textBoxMessage.Text = message + "\r\n" + textBoxMessage.Text;
		}

		private void PrintDebug(string m, params object []args)
		{
			if(Debug)
			{
				PrintMessage(m,args);
			}
		}

		private void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m, args);
		}

		//oCgz񂩂CŌNUL菜
		private byte[] ChopBytes(byte [] bytes)
		{
			int cnt=0;
			byte [] choppedBytes;
			for(int i= bytes.Length;i>0;i--)
			{
				if(bytes[i-1] == 0x00)
				{
					cnt ++;
				}
				else
				{
					break;
				}
			}

			choppedBytes = new byte [bytes.Length - cnt];
			Array.Copy(bytes,0,choppedBytes,0,bytes.Length - cnt);
			
			return choppedBytes;
		}

		//R|[lg̏Ԃς
		private void ChangeComponentState(Modes m)
		{
			mode = m;
			switch(mode)
			{
				case Modes.Init:
					buttonClose.Enabled = false;
					buttonOpen.Enabled = true;
					//buttonProgram.Enabled = false;
					buttonRead.Enabled =false;
					buttonReadStart.Enabled = false;
					buttonReadStop.Enabled = false;
					comboBoxPort.Enabled = true;
					//textBoxProgram.Enabled = false;
					break;

				case Modes.Open:
					buttonClose.Enabled = true;
					buttonOpen.Enabled = false;
					//buttonProgram.Enabled = true;
					buttonRead.Enabled =true;
					buttonReadStart.Enabled = true;
					buttonReadStop.Enabled = false;
					comboBoxPort.Enabled = false;
					//textBoxProgram.Enabled = true;
					break;

				case Modes.Read:
					buttonClose.Enabled = true;
					buttonOpen.Enabled = false;
					//buttonProgram.Enabled = false;
					buttonRead.Enabled =true;
					buttonReadStart.Enabled = false;
					buttonReadStop.Enabled = true;
					comboBoxPort.Enabled = false;
					//textBoxProgram.Enabled = false;
		
					break;
			}
			return;
		}

		//SẴXbh~
		private void StopAllThreads()
		{
			if(rxThread != null)
			{
				rxThread.Abort();
			}	
			if(txThread !=null)
			{
				txThread.Abort();
			}
			
			if(extThreadHolder.Count > 0)
			{
				
				string [] tmpKeys = new string[extThreadHolder.Count];
				int tmpCnt = 0;
				foreach(string key in extThreadHolder.Keys)
				{
					tmpKeys[tmpCnt] = key;
					tmpCnt++;
				}
				foreach(string key in tmpKeys)
				{
					if(((Thread)extThreadHolder[key]) != null)
					{
						((Thread)extThreadHolder[key]).Abort();
						((Thread)extThreadHolder[key]).Join();
						//((Thread)extThreadHolder[key]) = null;
						extThreadHolder.Remove(key);
					}
				}
			}
		}
		#endregion


		#region RFIDCommNXpRFID[_[Ƃ̒ʐM\bh
		//COM|[gJ
		void OpenPort()
		{
			if(rfid.IsOpen)
			{
				PrintMessage("{0}|[g͊ɃI[vĂ܂D", rfid.Port);
			}
			else
			{
				if(rfid.Open())
				{
					PrintMessage("{0}|[gI[v܂D", rfid.Port);
					if(rxThread == null)
					{
						rxThread = new Thread(new ThreadStart(ReadIdWorker));
						rxThread.Start();
					}
					ChangeComponentState(Modes.Open);
				}
				else
				{
					PrintError("{0}|[g̃I[vɎs܂D", rfid.Port);
				}
			}
		}

		//COM|[g
		void ClosePort()
		{
			if(rfid.IsOpen)
			{
				//SendCommand(IdTx.Read);
				rfid.Close();
				if(rxThread != null && rxThread.IsAlive)
				{
					rxThread.Abort();
					rxThread = null;
				}
				if(txThread !=null && txThread.IsAlive)
				{
					txThread.Abort();
					txThread = null;
				}
				PrintMessage("{0}|[gN[Y܂D", rfid.Port);
				ChangeComponentState(Modes.Init);
			}
			else
			{
				PrintError("{0}|[g͊JĂ܂D", rfid.Port);
			}
			return;
		}

		//ǂݎCAǂݎ̃R}h𑗂
		void SendCommand(IdTx id)
		{
			byte []data = new byte[1];
			SendCommand(id, 0, 0,data);
			return;
		}

		//(ǂݎCAǂݎ)C݂̃R}h𑗂
		void SendCommand(IdTx idType, uint address, byte block, byte [] data)
		{
			if(!(rfid.IsOpen))
			{
				PrintError("{0}|[g̓I[vĂ܂D", rfid.Port);
				return;
			}
			
			if(rfid.SendMessage(idType, address, block, data))
			{
				//PrintDebug("RFID[_ɃbZ[W𑗐M܂)";
			}
			else
			{
				PrintError("RFID[_ւ̃bZ[W̑MɎs܂");
			}	
			
		}

		//XbhJn
		private void StartTxThread()
		{
			if(txThread == null)
			{
				txThread = new Thread(new ThreadStart(SendMessageWorker));
				txThread.Start();
				ChangeComponentState(Modes.Read);
			}
		}

		//Xbh~
		private void StopTxThread()
		{
			if(txThread != null)
			{
				txThread.Abort();
				txThread = null;
				ChangeComponentState(Modes.Open);
			}
		}

		//AǂݎXbh
		private void SendMessageWorker()
		{
			try
			{
				while(true)
				{
					SendCommand(IdTx.Inventory);
					Thread.Sleep(DefaultInterval);
				}
			}
			catch(ThreadAbortException ex)
			{
				return;
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
				return;
			}
		}


		//AǂݎpXbh
		void ReadIdWorker()
		{
			byte [] rxBytes = new byte[DefaultBufferSize];

			while(true)
			{
				if(!rfid.IsOpen)
				{
					PrintError("|[gJ܂DǂݎXbhI܂D");
					break;
				}

				rxBytes = new byte[DefaultBufferSize];

				RfidData [] rfidDatas = null;

				if(rfid.ReceiveMessage(ref rxBytes, ref rfidDatas))
				{	
					//IDFȂꍇ.
					if(rfidDatas == null)
					{
						PrintDebug("^O܂");
						listViewId.Clear();

						//OXbhI邩ǂ̏
						foreach(string key in extThreadHolder.Keys)
						{
							string []ids = key.Split(multiIdSeparater.ToCharArray());

							((Thread)extThreadHolder[key]).Abort();
							((Thread)extThreadHolder[key]).Join();
							
							//IDrnbV폜
							for(int j=0;j<ids.Length;j++)
							{
								if(excludeIdHolder.Contains(ids[j]))
								{
									excludeIdHolder.Remove(ids[j]);
								}
								if(excludeIdMultiHolder.Contains(ids[j]))
								{
									excludeIdMultiHolder.Remove(ids[j]);
								}

							}
						}
						extThreadHolder.Clear();
					}
					//IDȏFĂꍇ
					else
					{
						int count = rfidDatas.Length;
						for(int i=0;i<count;i++)
						{	
							ListViewItem item = new ListViewItem(rfidDatas[i].id.ToString());
							
							bool containFlag = false;

							for(int j=0;j<listViewId.Items.Count;j++)
							{
								if(listViewId.Items[j].Text == item.Text)
								{
									containFlag = true;
									break;
								}
							}
							if(!containFlag)
							{		
								listViewId.Items.Add(item);	
							}
						}
						for(int i=0;i<listViewId.Items.Count;i++)
						{
							bool containFlag = false;

							for(int j=0;j<count;j++)
							{
								//string item = rfidDatas[j].id.ToString();
								ListViewItem item = new ListViewItem(rfidDatas[j].id.ToString());	
								if(listViewId.Items[i].Text == item.Text)
								{
									containFlag = true;
									break;
									//listViewId.Items.Add();	
								}
							}
							if(!containFlag)
							{
								listViewId.Items.RemoveAt(i);
							}
						}

						//oꂽIDnbVɊi[
						Hashtable tmpHolder = new Hashtable();
						for(int j=0;j<count;j++)
						{
							string id = listViewId.Items[j].Text;
							tmpHolder.Add(j, id);
						}

						//OXbhI邩ǂ̏
						string [] tmpKeys = new string[extThreadHolder.Count];
						int tmpCnt = 0;
						foreach(string key in extThreadHolder.Keys)
						{
							tmpKeys[tmpCnt] = key;
							tmpCnt++;
						}
						foreach(string key in tmpKeys)
						{
							string []ids = key.Split(multiIdSeparater.ToCharArray());
							bool flag =false;

							//ł܂܂ȂIDXbhID
							for(int i=0;i<ids.Length;i++)
							{
								if(tmpHolder.ContainsValue(ids[i]))
								{
									flag = true;
								}
								else
								{
									flag = false;
									break;
								}
							}

							if(!flag)
							{
								if(extThreadHolder.Contains(key))
								{
									if(((Thread)extThreadHolder[key]) != null)
									{
										((Thread)extThreadHolder[key]).Abort();
										((Thread)extThreadHolder[key]).Join();
										extThreadHolder.Remove(key);
									}
								}

								//IDrnbV폜
								for(int j=0;j<ids.Length;j++)
								{
									if(excludeIdHolder.Contains(ids[j]))
									{
										excludeIdHolder.Remove(ids[j]);
									}
									if(excludeIdMultiHolder.Contains(ids[j]))
									{
										excludeIdMultiHolder.Remove(ids[j]);
									}
								}

							}
							
						}

						//CxgoȂꍇ̓XLbv
						if(!eventEnabled)
						{	
							continue;
						}

						//o^ς݂̑gݍ킹IDƔr
						if(multiIdEnabled && itemMultiHolder.Count > 0)
						{
							//o^ς݂̑gݍ킹IDꂼ̏ꍇɂČJԂD
							Item []items =new Item[itemMultiHolder.Count];
							itemMultiHolder.Values.CopyTo(items,0);

							for(int i =0;i<items.Length;i++)
							{
								string []ids = items[i].id.Split(multiIdSeparater.ToCharArray());
				
								//FĂIDXgɁCgݍ킹IDSĂ܂܂Ă邩H
								bool flag = false;
								for(int j=0;j<ids.Length;j++)
								{
									//łɓIDFĂꍇ͏I
									if(excludeIdMultiHolder.ContainsValue(ids[j]))
									{
										flag = false;
										break;
									}

									if(tmpHolder.ContainsValue(ids[j]))
									{
										flag = true;
									}
									else
									{
										flag = false;
										break;
									}
								}
								if(flag)
								{
									//gݍ킹ID͑SĔF
									//IDłɃnbVɓo^ĂȂ΁CXbhNǉD
									if(!extThreadHolder.ContainsKey(items[i].id))
									{
										eventItem = items[i];
										Thread thread = new Thread(new ThreadStart(DealEventWorker));
										thread.Start();
										extThreadHolder.Add(items[i].id, thread);

										//IDrnbVɓo^
										for(int j=0;j<ids.Length;j++)
										{	
											if(!excludeIdMultiHolder.Contains(ids[j]))
											{
												excludeIdMultiHolder.Add(ids[j], ids[j]);
											}
											//P̔rnbVɂID܂܂Ă~
											if(extThreadHolder.Contains(ids[j]))
											{
												if(((Thread)extThreadHolder[ids[j]]) != null)
												{
													((Thread)extThreadHolder[ids[j]]).Abort();
													((Thread)extThreadHolder[ids[j]]).Join();
													extThreadHolder.Remove(ids[j]);
												}
											}
											if(excludeIdHolder.Contains(ids[j]))
											{
												excludeIdHolder.Remove(ids[j]);
											}
										}
									}	
								}
							}	
						}

						//o^ς݂̒PIDƔr
						if(itemHolder.Count > 0)
						{
							Item []items =new Item[itemHolder.Count];
							itemHolder.Values.CopyTo(items,0);
							
							for(int i =0;i<items.Length;i++)
							{
							
								if(excludeIdHolder.ContainsValue(items[i].id))
								{
									continue;
								}
								else if(excludeIdMultiHolder.ContainsValue(items[i].id))
								{
									continue;
								}

								if(tmpHolder.ContainsValue(items[i].id))
								{
									if(!extThreadHolder.Contains(items[i].id))
									{
										eventItem = items[i];
										Thread thread = new Thread(new ThreadStart(DealEventWorker));
										
										extThreadHolder.Add(items[i].id, thread);
										excludeIdHolder.Add(items[i].id, items[i].id);
										thread.Start();
									}	
								}
							}
						}
					}

				}
				else
				{
					//PrintError("|[gJ܂DǂݎXbhI܂D");
					//break;
				}
				Thread.Sleep(50);
			}
			return;
		}		
		#endregion

		//o^ςIDF̏sXbhD̏sꍇ͂ɋLqD
		private void DealEventWorker()
		{
			//̃XbhŗpItemiIDCvOCIvVȂǁjo^
			Item eItem = new Item(eventItem.id, eventItem.name, eventItem.program, eventItem.options);
			//OR}hĂяop̃vZX
			Process extProcess = null;

			//OvZX̋N
			try
			{
				if(eItem !=null && eItem.program != "" && eItem.options != null)
				{
					extProcess = new Process();
					extProcess.EnableRaisingEvents = false;			//OvZXIEvent𔭐邩H
					extProcess.StartInfo.FileName = eItem.program;	//NvO
					extProcess.StartInfo.UseShellExecute = false;	
					foreach(string option in eItem.options)
					{
						extProcess.StartInfo.Arguments = extProcess.StartInfo.Arguments + " " + option;
					}
					extProcess.Start();								//vZXX^[g
				}
				while(true)
				{	
					//I܂őҋ@
					Thread.Sleep(100);
				}
			}
			catch(ThreadAbortException ex)
			{
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				//OvZXIƁC݂̃XbhI͗lD
				if(extProcess!=null)
					extProcess.Kill();
			}		
		}

		[STAThread]
		static void Main(string[] args)
		{
			Application.Run(new RFIDForm());
		}


	}
}
